  /*  menu.c - powershell
   *  Copyright (C) 1999  Matt Spong <spong@glue.umd.edu>
   *  Based from zterm.c by Michael Zucci from the libzvt docs
   *
   *  A big, puffy lotsa-shells-in-one app. 
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "powershell.h"

GnomeUIInfo * file_menu, *file_menu2;
GnomeUIInfo edit_menu[] = {
  GNOMEUIINFO_MENU_CUT_ITEM (MenuHandler, 101),
  GNOMEUIINFO_MENU_COPY_ITEM (MenuHandler, 102),
  GNOMEUIINFO_MENU_PASTE_ITEM (MenuHandler, 103),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_MENU_PREFERENCES_ITEM (MenuHandler, 104),
  GNOMEUIINFO_MENU_NEW_ITEM ("Choose Font...", "Choose a font", MenuHandler, 105),
  GNOMEUIINFO_END
};

GnomeUIInfo help_menu[] = {
  GNOMEUIINFO_HELP("powershell"),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_MENU_ABOUT_ITEM(MenuHandler, 1001),
  GNOMEUIINFO_END
};

int mn, mn2;

GnomeUIInfo menubar[5];
GtkWidget * hidemenubaritem, * hidemenubaritem2;
GtkWidget * hidestatusbaritem, * hidestatusbaritem2;

int InitMenus (GtkWidget * window)
{
  int a;
  char * tmp;
  int rebuilding=0;

  if (GNOME_APP(window)->menubar)
    {
      /* this is probably going to cause a memory leak.
	 it shouldn't be too big, but I think it's there.

	 I'll have to find a better way to do this later.
      */

      rebuilding = 1;

      free (file_menu);
      free (file_menu2);
    }

  bzero (menubar, sizeof(GnomeUIInfo) * 5);

  file_menu = (GnomeUIInfo *)malloc (sizeof(GnomeUIInfo) * (num_apps+10));
  file_menu2 =(GnomeUIInfo *)malloc (sizeof(GnomeUIInfo) * (num_apps+10));

  for (a=0;a<num_apps;a++)
    {
      file_menu[a].label = app_entries[a].menu_item_title;

      /*      file_menu[a].label = (gchar *)malloc (strlen(app_entries[a].menu_item_title)+1);*/
      strcpy (file_menu[a].label, app_entries[a].menu_item_title);
      file_menu[a].accelerator_key = 0;
      file_menu[a].moreinfo = MenuHandler;
      file_menu[a].user_data = (gpointer) (a+1);

      file_menu[a].hint = app_entries[a].command;
      /*      file_menu[a].hint = (gchar *)malloc(strlen(app_entries[a].command)+1);*/
      strcpy (file_menu[a].hint, app_entries[a].command);

      file_menu[a].type = GNOME_APP_UI_ITEM;
      tmp = strstr (app_entries[a].command, "%s");
      file_menu[a].pixmap_type = GNOME_APP_PIXMAP_STOCK;
      file_menu[a].pixmap_info = tmp ? GNOME_STOCK_PIXMAP_CONVERT : GNOME_STOCK_MENU_EXEC;
    }
  file_menu[a].type = GNOME_APP_UI_SEPARATOR;
  
  a++;
  file_menu[a].type = GNOME_APP_UI_ITEM;
  file_menu[a].label = (gchar *)malloc (13);
  strcpy (file_menu[a].label, "_Rename Term");
  file_menu[a].accelerator_key = 0;
  file_menu[a].moreinfo = MenuHandler;
  file_menu[a].user_data = (gpointer) 97;
  file_menu[a].hint = "Rename Term";
  file_menu[a].pixmap_type = GNOME_APP_PIXMAP_STOCK;
  file_menu[a].pixmap_info = GNOME_STOCK_MENU_REFRESH;

  a++;
  file_menu[a].type = GNOME_APP_UI_ITEM;
  file_menu[a].label = (gchar *)malloc (8);
  strcpy (file_menu[a].label, "_Run...");
  file_menu[a].accelerator_key = 0;
  file_menu[a].moreinfo = MenuHandler;
  file_menu[a].user_data = (gpointer) 96;
  file_menu[a].hint = "Run a Program";
  file_menu[a].pixmap_type = GNOME_APP_PIXMAP_STOCK;
  file_menu[a].pixmap_info = GNOME_STOCK_MENU_BOOK_BLUE;
  
  a++;
  file_menu[a].type = GNOME_APP_UI_SEPARATOR;
  
  a++;
  file_menu[a].type = GNOME_APP_UI_ITEM;
  file_menu[a].label = (gchar *)malloc (7);
  strcpy (file_menu[a].label, "_Close");
  file_menu[a].accelerator_key = 0;
  file_menu[a].moreinfo = MenuHandler;
  file_menu[a].user_data = (gpointer) 98;
  file_menu[a].hint = "Close this Terminal";
  file_menu[a].pixmap_type = GNOME_APP_PIXMAP_STOCK;
  file_menu[a].pixmap_info = GNOME_STOCK_MENU_CLOSE;

  a++;
  file_menu[a].type = GNOME_APP_UI_TOGGLEITEM;
  file_menu[a].label = (gchar *)malloc (15);

  strcpy (file_menu[a].label, "_Hide Menu Bar");

  file_menu[a].accelerator_key = 0;
  file_menu[a].moreinfo = MenuHandler;
  file_menu[a].user_data = (gpointer) 94;
  file_menu[a].hint = "Hide or Unhide the Menu Bar";
  file_menu[a].pixmap_type = GNOME_APP_PIXMAP_NONE;
  file_menu[a].pixmap_info = (gpointer)0;

  mn = a;
  
  a++;
  file_menu[a].type = GNOME_APP_UI_TOGGLEITEM;
  file_menu[a].label = (gchar *)malloc (15);

  strcpy (file_menu[a].label, "_Hide Status Bar");

  file_menu[a].accelerator_key = 0;
  file_menu[a].moreinfo = MenuHandler;
  file_menu[a].user_data = (gpointer) 93;
  file_menu[a].hint = "Hide or Unhide the Status Bar";
  file_menu[a].pixmap_type = GNOME_APP_PIXMAP_NONE;
  file_menu[a].pixmap_info = (gpointer)0;

  mn2 = a;
  
  a++;
  file_menu[a].type = GNOME_APP_UI_ITEM;
  file_menu[a].label = (gchar *)malloc (6);
  strcpy (file_menu[a].label, "_Quit");
  file_menu[a].accelerator_key = 0;
  file_menu[a].moreinfo = MenuHandler;
  file_menu[a].user_data = (gpointer) 99;
  file_menu[a].hint = "Quit the Program";
  file_menu[a].pixmap_type = GNOME_APP_PIXMAP_STOCK;
  file_menu[a].pixmap_info = GNOME_STOCK_MENU_QUIT;

  a++;
  file_menu[a].type = GNOME_APP_UI_ENDOFINFO;

  menubar[0].type = GNOME_APP_UI_SUBTREE;
  menubar[0].label = (gchar *)malloc (6);
  strcpy (menubar[0].label, "_File");
  menubar[0].hint = (gchar *)malloc (10);
  strcpy (menubar[0].hint, "File Menu");
  menubar[0].moreinfo = (gpointer)file_menu;
  
  menubar[1].type = GNOME_APP_UI_SUBTREE;
  menubar[1].label = (gchar *)malloc (6);
  strcpy (menubar[1].label, "_Edit");
  menubar[1].hint = (gchar *)malloc (10);
  strcpy (menubar[1].hint, "Edit Menu");
  menubar[1].moreinfo = (gpointer)edit_menu;

  menubar[2].type = GNOME_APP_UI_SUBTREE;
  menubar[2].label = (gchar *)malloc (6);
  strcpy (menubar[2].label, "_Help");
  menubar[2].hint = (gchar *)malloc (10);
  strcpy (menubar[2].hint, "Help Menu");
  menubar[2].moreinfo = (gpointer)help_menu;

  menubar[3].type = GNOME_APP_UI_ENDOFINFO;

  for (a=0;a<num_apps+10;a++)
    file_menu2[a] = file_menu[a];

  if (!rebuilding)
    {
      gnome_app_create_menus (GNOME_APP(window), menubar);
       
      hidemenubaritem = (GtkWidget*)(&(file_menu[mn]));
      hidemenubaritem2 = (GtkWidget*)(&(file_menu2[mn]));

      hidestatusbaritem = (GtkWidget*)(&(file_menu[mn2]));
      hidestatusbaritem2 = (GtkWidget*)(&(file_menu2[mn2]));

    }
  else
    {
      gnome_app_remove_menus (GNOME_APP(window), "_File/", 1000);
      gnome_app_insert_menus (GNOME_APP(window), "_File/", file_menu);
    }

  gtk_widget_hide (file_menu[mn].widget);
  gtk_widget_hide (file_menu[mn2].widget);


  popup_file = gnome_popup_menu_new (file_menu2);

  GTK_CHECK_MENU_ITEM(file_menu2[mn].widget)->active = Prefs.hidemenubar;
  GTK_CHECK_MENU_ITEM(file_menu2[mn2].widget)->active = Prefs.hidestatusbar;
  
  return 0;
}



