  /*  prefs.c - powershell
   *  Copyright (C) 1999  Matt Spong <spong@glue.umd.edu>
   *  Based from zterm.c by Michael Zucci from the libzvt docs
   *
   *  A big, puffy lotsa-shells-in-one app. 
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * This code uses my patented "ugly-code" algorithm.  I'll fix it
 * at some point :-)
 */

#include "powershell.h"

ZvtTerm * current_term;

preferences Prefs;

GtkWidget * pbox;

GtkWidget * widget, * widget2, * widget3;  /* these are the different notebook
					      pages in the prefs dialog */
GtkWidget * widget4;

GtkWidget * dialog;
GtkWidget * hbox1, *hbox2, * vbox1, * vbox2, * vbox3, * vbox4, * vbox5;
GtkWidget * label1, * label2, * label3, * label4, * label5;
GtkWidget * label6, * label7, * label8, * label9;
GtkWidget * http_handler, * ftp_handler, * mail_handler, * telnet_handler, * bg_pixmap;
GtkWidget * use_pixmap, * transparent, * shaded, * use_matching;
GtkWidget * browse_button;

GtkWidget * menu_tab_title, * menu_command, * menu_menu_label;
GtkWidget * commands_list, * updatebutton, * buttonsbox;
GtkWidget * run_on_startup;

GtkWidget * hbox3, * vbox6, * vbox7, * hbox4, * vbox10;
GtkWidget * button1, *button2, *button3;

GtkWidget * cs_hbox1, * cs_hbox2, * cs_vbox1, * cs_vbox2;
GtkWidget * cs_vbox3, * cs_vbox4, * cs_vbox5;

GtkWidget * cs_dropscheme, * cs_dropfgbg;

GtkWidget * cs_schememenu, * cs_fgbgmenu;
GtkWidget * cs_schemelabel, * cs_fgbglabel, * cs_fglabel, * cs_bglabel;

GtkWidget * scrollposdrop, * scrollposmenu, * scrollposmenu;

GtkWidget * color_table, * color_table2;
GtkWidget * color_pickers[18];

guint nbtp;

GtkWidget * nbposmenu;

GtkWidget * menus[8];

GtkWidget * nbposmenuitems[5];
GtkWidget * scrollposmenuitems[3];

GtkWidget * vbox8, * hbox5, * vbox9;
GtkWidget * blinkcheckbox, * bellcheckbox, * scrollkeycheckbox, * scrolloutcheckbox, * delbscheckbox;
GtkWidget * scrolllineslabel, * scrolllinesentry;
GtkWidget * hidetabswhensingle;
GtkWidget * scrollbox;
GtkWidget * nbposdrop;

GtkWidget * run_def_shell;

GtkFileSelection * f;

int row_selected = -1;

int net_change;
int something_changed;

int scrollp;

int last_scheme, last_fgbg;

GtkWidget * ask_ssh_checkbox;

gchar * list_titles[] = {
  "Tab title", "Menu title", "Command", "Run on Startup"
};

extern GtkWidget * statusbar;
extern GnomeUIInfo menubar[5];
extern GnomeUIInfo * file_menu2;

static void property_changed (GtkWidget * w, gpointer user_data)
{
  gnome_property_box_changed (GNOME_PROPERTY_BOX(pbox));
}

static void update_menu_item (GtkWidget * w, gpointer user_data)
{
  gchar * mtt, * mc, * mml;
  gchar * txt[3];
  int ros;

  mtt = gtk_entry_get_text (GTK_ENTRY(menu_tab_title));
  mc = gtk_entry_get_text (GTK_ENTRY(menu_command));
  mml = gtk_entry_get_text (GTK_ENTRY(menu_menu_label));

  ros = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(run_on_startup));

  if (!mtt || !mc || !mml)
    return;

  if (!strlen(mtt) || !strlen(mc) || !strlen(mml))
    return;

  something_changed = 1;

  gtk_clist_set_text (GTK_CLIST(commands_list), row_selected, 0, mtt);
  gtk_clist_set_text (GTK_CLIST(commands_list), row_selected, 1, mml);
  gtk_clist_set_text (GTK_CLIST(commands_list), row_selected, 2, mc);
  gtk_clist_set_text (GTK_CLIST(commands_list), row_selected, 3, ros ? "Yes" : "No");

  property_changed (w, NULL);

}

static void add_menu_item (GtkWidget * w, gpointer user_data)
{
  gchar * mtt, * mc, * mml;
  gchar * txt[4];

  mtt = gtk_entry_get_text (GTK_ENTRY(menu_tab_title));
  mc = gtk_entry_get_text (GTK_ENTRY(menu_command));
  mml = gtk_entry_get_text (GTK_ENTRY(menu_menu_label));

  if (!mtt || !mc || !mml)
    return;
  
  if (!strlen(mtt) || !strlen(mc) || !strlen(mml))
    return;

  something_changed = 1;

  txt[0] = (gchar *)malloc (strlen(mtt)+1);
  txt[1] = (gchar *)malloc (strlen(mml)+1);
  txt[2] = (gchar *)malloc (strlen(mc)+1);
  txt[3] = (gchar *)malloc (4);
  strcpy (txt[0], mtt);
  strcpy (txt[1], mml);
  strcpy (txt[2], mc);
  strcpy (txt[3], gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(run_on_startup)) ? "Yes" : "No");

  gtk_clist_insert (GTK_CLIST(commands_list), row_selected, txt);

  free (txt[0]);
  free (txt[1]);
  free (txt[2]);
  free (txt[3]);

  gtk_entry_set_text (GTK_ENTRY(menu_tab_title), "");
  gtk_entry_set_text (GTK_ENTRY(menu_menu_label), "");
  gtk_entry_set_text (GTK_ENTRY(menu_command), "");  
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(run_on_startup), FALSE);
  net_change++;
  property_changed(w, NULL);
}

static void remove_menu_item (GtkWidget * w, gpointer user_data)
{
  if (row_selected >= 0)
    {
      gtk_clist_remove (GTK_CLIST(commands_list), row_selected);
      property_changed(w, NULL);
      net_change--;
      something_changed = 1;
    }
  
}

static void cb_row_selected (GtkCList * clist, gint row, gint column,
			  GdkEventButton * event)
{
  gchar * tmp1, *tmp2, *tmp3;
  int a;
  int ros;
  row_selected = row;
  gtk_clist_get_text (GTK_CLIST(commands_list), row_selected, 0, &tmp1);
  gtk_entry_set_text (GTK_ENTRY(menu_tab_title), tmp1);

  gtk_clist_get_text (GTK_CLIST(commands_list), row_selected, 1, &tmp2);
  gtk_entry_set_text (GTK_ENTRY(menu_menu_label), tmp2);
 
  gtk_clist_get_text (GTK_CLIST(commands_list), row_selected, 2, &tmp3);
  gtk_entry_set_text (GTK_ENTRY(menu_command), tmp3);

  gtk_clist_get_text (GTK_CLIST(commands_list), row_selected, 3, &tmp3);

  ros = 0;
  if (!strcmp (tmp3, "Yes"))
    ros = 1;

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(run_on_startup), ros);
  
}

static void property_apply (GnomePropertyBox *box, int page_num,
			    gpointer data)
{
  int a;
  gchar *tmp1, *tmp2, *tmp3, *tmp4;
  int num_rows;
  gushort dummy;
  gpointer temp[512];

  GtkWidget * menu_item;

#ifdef ZVT_USE_MATCHING  
  strcpy (Prefs.http_handler, gtk_entry_get_text (GTK_ENTRY(http_handler)));
  strcpy (Prefs.ftp_handler, gtk_entry_get_text (GTK_ENTRY(ftp_handler)));
  strcpy (Prefs.mail_handler, gtk_entry_get_text (GTK_ENTRY(mail_handler)));
  strcpy (Prefs.telnet_handler, gtk_entry_get_text (GTK_ENTRY(telnet_handler)));
  Prefs.use_matching = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(use_matching));
#endif
  Prefs.hidetabswhensingle = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(hidetabswhensingle));

  menu_item = gtk_menu_get_active (GTK_MENU(cs_schememenu));
  
  
  
  Prefs.use_pixmap = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(use_pixmap));
  Prefs.transparent = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(transparent));
  Prefs.shaded = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(shaded));

  ColorPrefs.bell = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(bellcheckbox));
  ColorPrefs.blink = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(blinkcheckbox));
  ColorPrefs.scroll_keystroke = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(scrollkeycheckbox));
  ColorPrefs.scroll_output = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(scrolloutcheckbox));

  ColorPrefs.del_bs_switch = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(delbscheckbox));
  Prefs.ask_ssh_password = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(ask_ssh_checkbox));
  strcpy (Prefs.bg_pixmap, gtk_entry_get_text (GTK_ENTRY(bg_pixmap)));

  Prefs.notebookpos = nbtp;
  Prefs.scrollbarpos = scrollp;

  num_rows = num_apps + net_change;

  free (app_entries);
  app_entries = (appentry *)malloc (sizeof(appentry) * num_rows);
  num_apps = num_rows;

  for (a=0;a<num_rows;a++)
    {
      gtk_clist_get_text (GTK_CLIST(commands_list), a, 0, &tmp1);
      gtk_clist_get_text (GTK_CLIST(commands_list), a, 1, &tmp2);
      gtk_clist_get_text (GTK_CLIST(commands_list), a, 2, &tmp3);
      gtk_clist_get_text (GTK_CLIST(commands_list), a, 3, &tmp4);

      app_entries[a].tab_title = (gchar *)malloc (strlen(tmp1) +1);
      app_entries[a].menu_item_title = (gchar *)malloc (strlen(tmp2) + 1);
      app_entries[a].command = (gchar *)malloc (strlen(tmp3) + 1);

      app_entries[a].run_on_startup = !strcmp (tmp4, "Yes");

      strcpy (app_entries[a].tab_title, tmp1);
      strcpy (app_entries[a].menu_item_title, tmp2);
      strcpy (app_entries[a].command, tmp3);      
    }

  /*  gnome_app_set_menus (GNOME_APP(window), NULL);
      InitMenus(window);*/

  if (something_changed)
    {
      InitMenus (GTK_WIDGET(window));
      gnome_app_install_menu_hints (GNOME_APP(window),menubar);
      gnome_app_install_menu_hints (GNOME_APP(window),file_menu2);
    }

  ColorPrefs.palette = last_scheme;

  for (a=0;a<16;a++)
    {
      gnome_color_picker_get_i16 (GNOME_COLOR_PICKER(color_pickers[a]),
				  &ColorPrefs.red[a], &ColorPrefs.green[a], &ColorPrefs.blue[a], &dummy);
    }
  
  gnome_color_picker_get_i16 (GNOME_COLOR_PICKER(color_pickers[16]),
			      (gushort *)&ColorPrefs.fg[0], (gushort *)&ColorPrefs.fg[1], 
			      (gushort *)&ColorPrefs.fg[2], &dummy);
 
  gnome_color_picker_get_i16 (GNOME_COLOR_PICKER(color_pickers[17]),
			      (gushort *)&ColorPrefs.bg[0], (gushort *)&ColorPrefs.bg[1], 
			      (gushort *)&ColorPrefs.bg[2], &dummy);

  tmp1 = gtk_entry_get_text (GTK_ENTRY(scrolllinesentry));

  if (atoi(tmp1))
    Prefs.scrollbacklines = atoi (tmp1);
  scrollbacklines = Prefs.scrollbacklines;
 
  if (Prefs.notebookpos < 4)
    gtk_notebook_set_tab_pos (GTK_NOTEBOOK(notebook), Prefs.notebookpos);

  gtk_notebook_set_show_tabs (GTK_NOTEBOOK(notebook), Prefs.notebookpos!=4);

  if (Prefs.hidetabswhensingle)
  {
    gtk_notebook_set_show_tabs (GTK_NOTEBOOK(notebook), terms_open > 1);
    printf ("terms_open: %d\n", terms_open);
  }

  Prefs.run_def_shell = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(run_def_shell));

  
  WriteRCFile();
  UpdateAllTerms();

  something_changed = 0;
  net_change = 0;
 
}

void nbtabpos_event (GtkMenuItem *w, gpointer data)
{
  property_changed(NULL, NULL);
  nbtp = (int)data;
}

void scrollpos_event (GtkMenuItem * w, gpointer data)
{
  property_changed(NULL, NULL);
  scrollp = (int)data;
}


void color_menu_event (GtkMenuItem * w, gpointer data)
{
  int a;
  int changed = 0;
  int fgbg_changed = 0;

  switch ((int)data)
    {
    case 1:
      for (a=0;a<16;a++)
	{
	  gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[a]),
				      linux_red[a], linux_grn[a],
				      linux_blu[a], 0);

	  gtk_widget_set_sensitive (color_pickers[a], FALSE);
	  changed = 1;
	  last_scheme = PALETTE_LINUX;
	}
      break;

    case 2:
      for (a=0;a<16;a++)
	{
	  gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[a]),
				      xterm_red[a], xterm_grn[a],
				      xterm_blu[a], 0);


	  gtk_widget_set_sensitive (color_pickers[a], FALSE);
	  changed = 1;
	  last_scheme = PALETTE_XTERM;
	}
      break;
    case 3:
      for (a=0;a<16;a++)
	{
	  gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[a]),
				      rxvt_red[a], rxvt_grn[a],
				      rxvt_blu[a], 0);

	  gtk_widget_set_sensitive (color_pickers[a], FALSE);
	  changed = 1;
	  last_scheme = PALETTE_RXVT;
	}

      break;

    case 4:
      for (a=0;a<16;a++)
	{
	  gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[a]),
				      ColorPrefs.red[a], ColorPrefs.green[a],
				      ColorPrefs.blue[a], 0);
  
	  gtk_widget_set_sensitive (color_pickers[a], TRUE);
	}      
      last_scheme = PALETTE_CUSTOM;
      changed = 1;
      break;



    case 101:
      gtk_widget_set_sensitive (color_pickers[16], FALSE);
      gtk_widget_set_sensitive (color_pickers[17], FALSE);

      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[16]),
				  0xffff, 0xffff, 0xffff, 0);
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[17]),
				  0, 0, 0, 0);
      
      fgbg_changed = 1;
      break;

    case 102:

      gtk_widget_set_sensitive (color_pickers[16], FALSE);
      gtk_widget_set_sensitive (color_pickers[17], FALSE);
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[16]),
				  0, 0, 0, 0);
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[17]),
				  0xffff, 0xffff, 0xffff, 0);
      fgbg_changed = 1;
      break;

    case 103:

      ColorPrefs.fg[0] = 0;
      ColorPrefs.fg[1] = 0xffff;
      ColorPrefs.fg[2] = 0;

      ColorPrefs.bg[0] = 0;      
      ColorPrefs.bg[1] = 0;     
      ColorPrefs.bg[2] = 0;

      gtk_widget_set_sensitive (color_pickers[16], FALSE);
      gtk_widget_set_sensitive (color_pickers[17], FALSE);
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[16]),
				  0, 0xffff, 0, 0);
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[17]),
				  0, 0, 0, 0);
      fgbg_changed = 1;
      break;

    case 104:
      gtk_widget_set_sensitive (color_pickers[16], TRUE);
      gtk_widget_set_sensitive (color_pickers[17], TRUE);
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[16]),
				  ColorPrefs.fg[0], ColorPrefs.fg[1], ColorPrefs.fg[2], 0);
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[17]),
				  ColorPrefs.bg[0], ColorPrefs.bg[1], ColorPrefs.bg[2], 0);
      fgbg_changed = 1;
      break;
    }

  if (changed)
    {
      property_changed (GTK_WIDGET(w), NULL);
    }
    
  if (fgbg_changed)
    {
      property_changed (GTK_WIDGET(w), NULL);
    }
  
}

void CreatePrefs4 (GtkWidget * area)
{
  int a;
  int bscheme, bfgbg;

  cs_hbox1 = gtk_hbox_new (TRUE, 10);
  cs_hbox2 = gtk_hbox_new (TRUE, 10);
  cs_vbox1 = gtk_vbox_new (FALSE, 0);
  cs_vbox2 = gtk_vbox_new (FALSE, 0);

  cs_vbox3 = gtk_vbox_new (FALSE, 0);
  cs_vbox4 = gtk_vbox_new (FALSE, 0);
  cs_vbox5 = gtk_vbox_new (TRUE, 10);

  color_table = gtk_table_new (2, 8, TRUE);
  color_table2 = gtk_table_new (2, 8, TRUE);

  cs_schemelabel = gtk_label_new ("Color Scheme");
  cs_fgbglabel = gtk_label_new ("Foreground/Background");

  gtk_box_pack_start (GTK_BOX(area), cs_vbox5, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(cs_vbox5), cs_hbox1, TRUE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX(cs_hbox1), cs_vbox1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(cs_hbox1), cs_vbox2, TRUE, TRUE, 0);
  
  cs_schememenu = gtk_menu_new ();

  menus[0] = gtk_menu_item_new_with_label ("Linux Console");
  gtk_signal_connect (GTK_OBJECT(menus[0]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)1);

  gtk_menu_append (GTK_MENU(cs_schememenu), menus[0]);  
  

  menus[1] = gtk_menu_item_new_with_label ("XTerm");
  gtk_signal_connect (GTK_OBJECT(menus[1]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)2);

  gtk_menu_append (GTK_MENU(cs_schememenu), menus[1]);  


  menus[2] = gtk_menu_item_new_with_label ("RXVT");
  gtk_signal_connect (GTK_OBJECT(menus[2]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)3);

  gtk_menu_append (GTK_MENU(cs_schememenu), menus[2]);  

  menus[3] = gtk_menu_item_new_with_label ("Custom");
  gtk_signal_connect (GTK_OBJECT(menus[3]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)4);

  gtk_menu_append (GTK_MENU(cs_schememenu), menus[3]);  
 

  cs_fgbgmenu = gtk_menu_new ();

  menus[4] = gtk_menu_item_new_with_label ("White on Black");
  gtk_signal_connect (GTK_OBJECT(menus[4]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)101);

  gtk_menu_append (GTK_MENU(cs_fgbgmenu), menus[4]);  

  menus[5] = gtk_menu_item_new_with_label ("Black on White");
  gtk_signal_connect (GTK_OBJECT(menus[5]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)102);

  gtk_menu_append (GTK_MENU(cs_fgbgmenu), menus[5]);  


  menus[6] = gtk_menu_item_new_with_label ("Green on Black");
  gtk_signal_connect (GTK_OBJECT(menus[6]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)103);

  gtk_menu_append (GTK_MENU(cs_fgbgmenu), menus[6]);  

  menus[7] = gtk_menu_item_new_with_label ("Custom");
  gtk_signal_connect (GTK_OBJECT(menus[7]), "activate",
			     GTK_SIGNAL_FUNC (color_menu_event), (gpointer)104);

  gtk_menu_append (GTK_MENU(cs_fgbgmenu), menus[7]);  



  cs_dropscheme = gtk_option_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU(cs_dropscheme), GTK_WIDGET(cs_schememenu));

  cs_dropfgbg = gtk_option_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU(cs_dropfgbg), GTK_WIDGET (cs_fgbgmenu));

  gtk_box_pack_start (GTK_BOX(cs_vbox1), cs_schemelabel, TRUE, TRUE,0);
  gtk_box_pack_start (GTK_BOX(cs_vbox2), cs_dropscheme, TRUE, TRUE, 0);

  for (a=0;a<8;a++)
    {
      color_pickers[a] = gnome_color_picker_new ();
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[a]),
				  ColorPrefs.red[a], ColorPrefs.green[a],
				  ColorPrefs.blue[a], 0);

      gtk_table_attach_defaults (GTK_TABLE(color_table), GTK_WIDGET(color_pickers[a]),
			a, a+1, 0, 1);
 
      color_pickers[a+8] = gnome_color_picker_new ();
      gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[a+8]),
				  ColorPrefs.red[a+8], ColorPrefs.green[a+8],
				  ColorPrefs.blue[a+8], 0);

      gtk_table_attach_defaults (GTK_TABLE(color_table), GTK_WIDGET(color_pickers[a+8]),
			a, a+1, 1, 2);
 
   }

  gtk_box_pack_start (GTK_BOX(cs_vbox5), color_table, FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX(cs_vbox5), cs_hbox2, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(cs_hbox2), cs_vbox3, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(cs_hbox2), cs_vbox4, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX(cs_vbox3), cs_fgbglabel, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(cs_vbox4), cs_dropfgbg, TRUE, TRUE, 0);

  color_pickers[16] = gnome_color_picker_new();
  
  gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[16]),
				  ColorPrefs.fg[0], ColorPrefs.fg[1],
				  ColorPrefs.fg[2], 0);
 
  color_pickers[17] = gnome_color_picker_new();
  
  gnome_color_picker_set_i16 (GNOME_COLOR_PICKER(color_pickers[17]),
				  ColorPrefs.bg[0], ColorPrefs.bg[1],
				  ColorPrefs.bg[2], 0);

  cs_fglabel = gtk_label_new ("Foreground Color");
  cs_bglabel = gtk_label_new ("Background Color");

  gtk_table_attach_defaults (GTK_TABLE(color_table2), GTK_WIDGET(cs_fglabel),
			     0, 4, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE(color_table2), GTK_WIDGET(cs_bglabel),
			     0, 4, 1, 2);

  gtk_table_attach_defaults (GTK_TABLE(color_table2), GTK_WIDGET(color_pickers[16]),
			     4, 5, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE(color_table2), GTK_WIDGET(color_pickers[17]),
			     4, 5, 1, 2);

  gtk_box_pack_start (GTK_BOX(cs_vbox5), color_table2, FALSE, FALSE, 0);

  for (a=0;a<18;a++)
    gtk_signal_connect (GTK_OBJECT(color_pickers[a]), "color-set", GTK_SIGNAL_FUNC (property_changed), NULL);


  bscheme = ColorPrefs.palette;
  gtk_option_menu_set_history (GTK_OPTION_MENU(cs_dropscheme), bscheme);

  bfgbg = 7;

  if (!ColorPrefs.fg[0] && !ColorPrefs.fg[1] && !ColorPrefs.fg[2])
    if ((ColorPrefs.bg[0] == 0xffff)&&(ColorPrefs.bg[1] == 0xffff)&&(ColorPrefs.bg[2] == 0xffff))
      bfgbg = 5;

  if (!ColorPrefs.bg[0] && !ColorPrefs.bg[1] && !ColorPrefs.bg[2])
    if ((ColorPrefs.fg[0] == 0xffff)&&(ColorPrefs.fg[1] == 0xffff)&&(ColorPrefs.fg[2] == 0xffff))
      bfgbg = 4;

  if (!ColorPrefs.bg[0] && !ColorPrefs.bg[1] && !ColorPrefs.bg[2])
    if ((ColorPrefs.fg[0] == 0)&&(ColorPrefs.fg[1] == 0xffff)&&(ColorPrefs.fg[2] == 0))
      bfgbg = 6;

  gtk_option_menu_set_history (GTK_OPTION_MENU(cs_dropfgbg), bfgbg-4);

  if (bscheme != PALETTE_CUSTOM)
    for (a=0;a<16;a++)
      gtk_widget_set_sensitive (color_pickers[a], FALSE);

  if (bfgbg != 7)
    {
      gtk_widget_set_sensitive (color_pickers[16], FALSE);
      gtk_widget_set_sensitive (color_pickers[17], FALSE);
      
    }

}

void CreatePrefs3 (GtkWidget * area)
{
  int a;
  gchar * entries[4];
  net_change = 0;
  something_changed = 0;

  for (a=0;a<4;a++)
    entries[a] = (gchar *)malloc (256);

  hbox3 = gtk_hbox_new (TRUE, 0);
  hbox4 = gtk_hbox_new (TRUE, 0);
  vbox6 = gtk_vbox_new (TRUE, 0);
  vbox7 = gtk_vbox_new (TRUE, 0);
  vbox10 = gtk_vbox_new (FALSE, 0);

  buttonsbox = gtk_hbox_new (TRUE, 0);

  scrollbox = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(scrollbox),
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  gtk_widget_set_usize (GTK_WIDGET(scrollbox), 0, 200);

  gtk_widget_show (GTK_WIDGET(scrollbox));


  label6 = gtk_label_new ("Tab Title");
  label8 = gtk_label_new ("Command");
  label7 = gtk_label_new ("Menu Title");

  button1 = gtk_button_new_with_label ("Add");
  updatebutton = gtk_button_new_with_label ("Update");

  button2 = gtk_button_new_with_label ("Remove");

  commands_list = gtk_clist_new_with_titles (4, list_titles);

  menu_tab_title = gtk_entry_new();
  menu_command = gtk_entry_new();
  menu_menu_label = gtk_entry_new();

  run_on_startup = gtk_check_button_new_with_label ("Run on startup");



  gtk_box_pack_start (GTK_BOX(area), vbox10, TRUE, TRUE, 0);



  gtk_box_pack_start (GTK_BOX(vbox10), hbox3, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(hbox3), vbox6, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(hbox3), vbox7, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX(vbox6), label6, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(vbox6), label7, TRUE, TRUE, 0);  
  gtk_box_pack_start (GTK_BOX(vbox6), label8, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX(vbox10), run_on_startup, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX(vbox7), menu_tab_title, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(vbox7), menu_menu_label, TRUE, TRUE, 0);  
  gtk_box_pack_start (GTK_BOX(vbox7), menu_command, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX(vbox10), buttonsbox, FALSE, FALSE, 10);
  gtk_box_pack_start (GTK_BOX(buttonsbox), button1, TRUE, TRUE, 10);
  gtk_box_pack_start (GTK_BOX(buttonsbox), updatebutton, TRUE, TRUE, 10);

  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW(scrollbox),
					 GTK_WIDGET(commands_list));

  gtk_box_pack_start (GTK_BOX(vbox10), scrollbox, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(vbox10), button2, FALSE, FALSE, 0);

  gtk_clist_set_selection_mode (GTK_CLIST(commands_list), GTK_SELECTION_SINGLE);
  
  gtk_clist_set_column_width (GTK_CLIST(commands_list), 0, 100);
  gtk_clist_set_column_width (GTK_CLIST(commands_list), 1, 100);

  for (a=0;a<num_apps;a++)
    {
      strcpy (entries[0], app_entries[a].tab_title);
      strcpy (entries[1], app_entries[a].menu_item_title);
      strcpy (entries[2], app_entries[a].command);
      strcpy (entries[3], app_entries[a].run_on_startup ? "Yes" : "No");
      gtk_clist_append (GTK_CLIST(commands_list), entries);
    }

  gtk_signal_connect_object (GTK_OBJECT(button1), "clicked", 
			     GTK_SIGNAL_FUNC(add_menu_item), GTK_OBJECT(area));
  gtk_signal_connect_object (GTK_OBJECT(updatebutton), "clicked",
			     GTK_SIGNAL_FUNC(update_menu_item), GTK_OBJECT(area));
  gtk_signal_connect_object (GTK_OBJECT(button2), "clicked",
			     GTK_SIGNAL_FUNC(remove_menu_item), GTK_OBJECT(area));
  gtk_signal_connect_object (GTK_OBJECT(hidetabswhensingle), "toggled",
			     GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(area));

  gtk_signal_connect (GTK_OBJECT(commands_list), "select_row",
		      GTK_SIGNAL_FUNC (cb_row_selected),
		      NULL);

}


int DoPreferences ()
{
  pbox = gnome_property_box_new ();
  gtk_signal_connect (GTK_OBJECT(pbox), "apply",
		      GTK_SIGNAL_FUNC(property_apply), NULL);
  widget = gtk_vbox_new (FALSE, 0);

  CreatePrefs (widget);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget,
				  gtk_label_new ("Appearance"));

#ifdef ZVT_USE_MATCHING
  widget2 = gtk_vbox_new (FALSE, 0);
  CreatePrefs2 (widget2);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget2,
				  gtk_label_new ("Handlers"));
#endif

  widget4 = gtk_hbox_new (FALSE, 0);
  CreatePrefs4 (widget4);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget4,
				  gtk_label_new ("Colors"));

  

  widget3 = gtk_vbox_new (FALSE, 0);
  CreatePrefs3 (widget3);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget3,
				  gtk_label_new ("Menus"));

  gtk_widget_show_all (pbox);
}


void store_filename (GtkFileSelection * b, gpointer user_data)
{
  gchar * filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION(f));
  gtk_entry_set_text (GTK_ENTRY(bg_pixmap), filename);
}

void browse_clicked (GtkButton * button, gpointer data)
{
  gchar * filename;   
  f = GTK_FILE_SELECTION(gtk_file_selection_new ("Choose a Pixmap"));

  filename = gtk_entry_get_text (GTK_ENTRY(bg_pixmap));

  gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(f)->ok_button),
	 	      "clicked", GTK_SIGNAL_FUNC (store_filename), NULL);
  
  gtk_signal_connect_object (GTK_OBJECT(GTK_FILE_SELECTION(f)->cancel_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) f);
  
  gtk_signal_connect_object (GTK_OBJECT(GTK_FILE_SELECTION(f)->ok_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) f);

  if (filename)
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(f), filename);

  gtk_widget_show (GTK_WIDGET(f)); 
} 

int CreatePrefs2 (GtkContainer * area)
{
  gtk_box_pack_start (GTK_BOX(area), hbox1, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox1), GTK_WIDGET(vbox1), TRUE,FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox1), vbox2, TRUE, FALSE, 0);


  label1 = gtk_label_new ("HTTP Handler");
  label2 = gtk_label_new ("FTP Handler");
  label3 = gtk_label_new ("Mail Handler");
  label4 = gtk_label_new ("Telnet Handler");
  
  http_handler = gtk_entry_new ();
  ftp_handler = gtk_entry_new ();
  mail_handler = gtk_entry_new ();
  telnet_handler = gtk_entry_new ();


  gtk_box_pack_start (GTK_BOX(vbox1), label1, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox1), label2, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox1), label3, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox1), label4, TRUE, FALSE, 0);
  
  gtk_box_pack_start (GTK_BOX(vbox2), http_handler, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox2), ftp_handler, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox2), mail_handler, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox2), telnet_handler, TRUE, FALSE, 0);

  gtk_entry_set_text (GTK_ENTRY(http_handler), Prefs.http_handler);
  gtk_entry_set_text (GTK_ENTRY(ftp_handler), Prefs.ftp_handler);
  gtk_entry_set_text (GTK_ENTRY(mail_handler), Prefs.mail_handler);
  gtk_entry_set_text (GTK_ENTRY(telnet_handler), Prefs.telnet_handler);


  gtk_signal_connect_object (GTK_OBJECT(http_handler), "changed", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(area));
  gtk_signal_connect_object (GTK_OBJECT(ftp_handler), "changed", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(area));
  gtk_signal_connect_object (GTK_OBJECT(mail_handler), "changed", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(area));
  gtk_signal_connect_object (GTK_OBJECT(telnet_handler), "changed", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(area));

}

int CreatePrefs (GtkContainer * area)
{

  char tmp[256];

  GtkWidget * hbox15;

  hbox1 = gtk_hbox_new (FALSE, 1);
  vbox1 = gtk_vbox_new (FALSE, 1);
  vbox2 = gtk_vbox_new (FALSE, 1);
  vbox3 = gtk_vbox_new (FALSE, 1);
  hbox2 = gtk_hbox_new (FALSE, 1);
  vbox4 = gtk_vbox_new (FALSE, 1);
  vbox5 = gtk_vbox_new (FALSE, 1);
  hbox15 = gtk_hbox_new (FALSE, 1);

  label5 = gtk_label_new ("Background Pixmap");

  bg_pixmap = gtk_entry_new();
  use_pixmap = gtk_check_button_new_with_label ("Use Background Pixmap");
  transparent = gtk_check_button_new_with_label ("Transparent");
  shaded = gtk_check_button_new_with_label ("Shaded");

  hidetabswhensingle = gtk_check_button_new_with_label ("Hide tabs if only running a single term");


  gtk_box_pack_start (GTK_BOX(area), vbox10, TRUE, TRUE, 0);

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(hidetabswhensingle), Prefs.hidetabswhensingle);

  ask_ssh_checkbox = gtk_check_button_new_with_label ("Ask for SSH Password");
  gtk_widget_set_sensitive (GTK_WIDGET(ask_ssh_checkbox), FALSE);

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(use_pixmap), Prefs.use_pixmap);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(transparent), Prefs.transparent);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(shaded), Prefs.shaded);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(ask_ssh_checkbox), Prefs.ask_ssh_password);



  gtk_entry_set_text (GTK_ENTRY(bg_pixmap), Prefs.bg_pixmap);

  gtk_box_pack_start (GTK_BOX(area), vbox4, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox4), vbox5, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox5), transparent, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox5), shaded, TRUE, FALSE, 0);


  gtk_box_pack_start (GTK_BOX(vbox4), use_pixmap, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox4), hbox2, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox2), label5, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox2), bg_pixmap, TRUE, FALSE, 0);

#ifdef ZVT_USE_MATCHING
  use_matching = gtk_check_button_new_with_label ("Use URL Matching");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(use_matching), Prefs.use_matching);

  gtk_signal_connect_object (GTK_OBJECT(use_matching), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));

#endif

  browse_button = gtk_button_new_with_label ("Browse...");

  gtk_box_pack_start (GTK_BOX(hbox2), browse_button, FALSE, FALSE, 30);

  gtk_signal_connect_object (GTK_OBJECT(use_pixmap), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
    gtk_signal_connect_object (GTK_OBJECT(transparent), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
  gtk_signal_connect_object (GTK_OBJECT(shaded), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));

  gtk_signal_connect_object (GTK_OBJECT(bg_pixmap), "changed", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));

  gtk_signal_connect_object (GTK_OBJECT(ask_ssh_checkbox), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));


  gtk_signal_connect_object (GTK_OBJECT(browse_button), "clicked",
			     GTK_SIGNAL_FUNC (browse_clicked), GTK_OBJECT(pbox));

  vbox8 = gtk_vbox_new (FALSE, 0);
  hbox5 = gtk_hbox_new (FALSE, 0);
  vbox9 = gtk_vbox_new (FALSE, 0);

  gtk_box_pack_start (GTK_BOX(area), hbox5, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(area), hbox15, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox5), vbox8, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox5), vbox9, TRUE, FALSE, 0);


  run_def_shell = gtk_check_button_new_with_label ("Always Run Default Shell");
  blinkcheckbox = gtk_check_button_new_with_label ("Use blinking cursor");
  bellcheckbox = gtk_check_button_new_with_label ("Enable terminal bell");
  scrollkeycheckbox = gtk_check_button_new_with_label ("Scroll on keystroke");
  scrolloutcheckbox = gtk_check_button_new_with_label ("Scroll on output");
  delbscheckbox = gtk_check_button_new_with_label ("Swap backspace/delete");


  scrolllineslabel = gtk_label_new ("Scrollback lines");
  scrolllinesentry = gtk_entry_new ();

  gtk_box_pack_start (GTK_BOX(vbox8), run_def_shell, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox8), blinkcheckbox, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox8), bellcheckbox, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox8), scrollkeycheckbox, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox8), scrolloutcheckbox, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox8), delbscheckbox, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox8), ask_ssh_checkbox, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(vbox8), hidetabswhensingle, TRUE, FALSE, 0);

#ifdef ZVT_USE_MATCHING
  gtk_box_pack_start (GTK_BOX(vbox8), use_matching, TRUE, FALSE, 0);
#endif

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(run_def_shell), Prefs.run_def_shell);

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(blinkcheckbox), ColorPrefs.blink);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(bellcheckbox), ColorPrefs.bell);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(scrollkeycheckbox), ColorPrefs.scroll_keystroke);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(scrolloutcheckbox), ColorPrefs.scroll_output);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(delbscheckbox), ColorPrefs.del_bs_switch);

  gtk_box_pack_start (GTK_BOX(hbox5), scrolllineslabel, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox5), scrolllinesentry, TRUE, FALSE, 0);

  nbposmenu = gtk_menu_new ();

  nbposmenuitems[0] = gtk_menu_item_new_with_label ("Left");
  gtk_signal_connect (GTK_OBJECT(nbposmenuitems[0]), "activate",
			     GTK_SIGNAL_FUNC (nbtabpos_event), (gpointer)0);

  gtk_menu_append (GTK_MENU(nbposmenu), nbposmenuitems[0]);  

  nbposmenuitems[1] = gtk_menu_item_new_with_label ("Right");
  gtk_signal_connect (GTK_OBJECT(nbposmenuitems[1]), "activate",
			     GTK_SIGNAL_FUNC (nbtabpos_event), (gpointer)1);

  gtk_menu_append (GTK_MENU(nbposmenu), nbposmenuitems[1]);  

  nbposmenuitems[2] = gtk_menu_item_new_with_label ("Top");
  gtk_signal_connect (GTK_OBJECT(nbposmenuitems[2]), "activate",
			     GTK_SIGNAL_FUNC (nbtabpos_event), (gpointer)2);

  gtk_menu_append (GTK_MENU(nbposmenu), nbposmenuitems[2]);  

  nbposmenuitems[3] = gtk_menu_item_new_with_label ("Bottom");
  gtk_signal_connect (GTK_OBJECT(nbposmenuitems[3]), "activate",
			     GTK_SIGNAL_FUNC (nbtabpos_event), (gpointer)3);

  gtk_menu_append (GTK_MENU(nbposmenu), nbposmenuitems[3]);  
  
  nbposmenuitems[4] = gtk_menu_item_new_with_label ("Hidden");
  gtk_signal_connect (GTK_OBJECT(nbposmenuitems[4]), "activate",
			     GTK_SIGNAL_FUNC (nbtabpos_event), (gpointer)4);

  gtk_menu_append (GTK_MENU(nbposmenu), nbposmenuitems[4]);  

  
  scrollposmenu = gtk_menu_new ();

  scrollposmenuitems[0] = gtk_menu_item_new_with_label ("Right");
  gtk_signal_connect (GTK_OBJECT(scrollposmenuitems[0]), "activate",
		      GTK_SIGNAL_FUNC (scrollpos_event), (gpointer) 0);
  gtk_menu_append (GTK_MENU(scrollposmenu), scrollposmenuitems[0]);

  scrollposmenuitems[1] = gtk_menu_item_new_with_label ("Left");
  gtk_signal_connect (GTK_OBJECT(scrollposmenuitems[1]), "activate",
		      GTK_SIGNAL_FUNC (scrollpos_event), (gpointer) 1);
  gtk_menu_append (GTK_MENU(scrollposmenu), scrollposmenuitems[1]);

  scrollposmenuitems[2] = gtk_menu_item_new_with_label ("Hidden");
  gtk_signal_connect (GTK_OBJECT(scrollposmenuitems[2]), "activate",
		      GTK_SIGNAL_FUNC (scrollpos_event), (gpointer) 2);
  gtk_menu_append (GTK_MENU(scrollposmenu), scrollposmenuitems[2]);


  


  nbposdrop = gtk_option_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU(nbposdrop), GTK_WIDGET(nbposmenu));

  gtk_box_pack_start (GTK_BOX(hbox15), gtk_label_new ("Tab Position "), TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox15), nbposdrop, TRUE, TRUE, 0);

  gtk_option_menu_set_history (GTK_OPTION_MENU(nbposdrop), Prefs.notebookpos);

  nbtp = Prefs.notebookpos;

  scrollposdrop = gtk_option_menu_new();
  gtk_option_menu_set_menu (GTK_OPTION_MENU(scrollposdrop), GTK_WIDGET(scrollposmenu));

  gtk_box_pack_start (GTK_BOX(hbox15), gtk_label_new ("Scrollbar Position"), TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX(hbox15), scrollposdrop, TRUE, TRUE, 0);
  gtk_option_menu_set_history (GTK_OPTION_MENU(scrollposdrop), Prefs.scrollbarpos);
  
  scrollp = Prefs.scrollbarpos;


  sprintf (tmp, "%d", scrollbacklines);
  gtk_entry_set_text (GTK_ENTRY(scrolllinesentry), tmp);
  
  gtk_signal_connect_object (GTK_OBJECT(run_def_shell), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
  gtk_signal_connect_object (GTK_OBJECT(blinkcheckbox), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
  gtk_signal_connect_object (GTK_OBJECT(bellcheckbox), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
  gtk_signal_connect_object (GTK_OBJECT(scrollkeycheckbox), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
  gtk_signal_connect_object (GTK_OBJECT(scrolloutcheckbox), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
  gtk_signal_connect_object (GTK_OBJECT(delbscheckbox), "toggled", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));
  gtk_signal_connect_object (GTK_OBJECT(scrolllinesentry), "changed", GTK_SIGNAL_FUNC(property_changed), GTK_OBJECT(pbox));

}

